searchNodes=[{"doc":"LiveDashboard provides real-time performance monitoring and debugging tools for Phoenix developers. It provides the following modules:Home - See general information about the systemOS Data - See general information about OS, such as CPU, Memory and Disk usageMetrics - See how your application performs under different conditions by visualizing :telemetry events with real-time chartsRequest logging - See everything that was logged for certain requestsApplications - See, filter, and search applications in the current nodeProcesses - See, filter, and search processes in the current nodePorts - See, filter, and search ports (responsible for I/O) in the current nodeSockets - See, filter, and search sockets (responsible for tcp/udp) in the current nodeETS - See, filter, and search ETS tables (in-memory storage) in the current nodeThe dashboard also works across nodes. If your nodes are connected via Distributed Erlang, then you can access information from node B while accessing the dashboard on node A.InstallationTo start using LiveDashboard, you will need three steps:Add the phoenix_live_dashboard dependencyConfigure LiveViewAdd dashboard access1. Add the phoenix_live_dashboard dependencyAdd the following to your mix.exs and run mix deps.get:def deps do [ {:phoenix_live_dashboard, &quot;~&gt; 0.1&quot;} ] end2. Configure LiveViewThe LiveDashboard is built on top of LiveView. If LiveView is already installed in your app, feel free to skip this section.If you plan to use LiveView in your application in the future, we recommend you to follow the official installation instructions. This guide only covers the minimum steps necessary for the LiveDashboard itself to run.First, update your endpoint's configuration to include a signing salt. You can generate a signing salt by running mix phx.gen.secret 32 (note Phoenix v1.5+ apps already have this configuration):# config/config.exs config :my_app, MyAppWeb.Endpoint, live_view: [signing_salt: &quot;SECRET_SALT&quot;]Then add the Phoenix.LiveView.Socket declaration to your endpoint:socket &quot;/live&quot;, Phoenix.LiveView.SocketAnd you are good to go!3. Add dashboard access for development-only usageOnce installed, update your router's configuration to forward requests to a LiveDashboard with a unique name of your choosing:# lib/my_app_web/router.ex use MyAppWeb, :router import Phoenix.LiveDashboard.Router ... if Mix.env() == :dev do scope &quot;/&quot; do pipe_through :browser live_dashboard &quot;/dashboard&quot; end endThis is all. Run mix phx.server and access the &quot;/dashboard&quot; to configure the necessary modules.Extra: Add dashboard access on all environments (including production)If you want to use the LiveDashboard in production, you should put it behind some authentication and allow only admins to access it. If your application does not have an admins-only section yet, you can use Plug.BasicAuth to set up some basic authentication as long as you are also using SSL (which you should anyway):# lib/my_app_web/router.ex use MyAppWeb, :router import Plug.BasicAuth import Phoenix.LiveDashboard.Router ... pipeline :admins_only do plug :basic_auth, username: &quot;admin&quot;, password: &quot;a very special secret&quot; end scope &quot;/&quot; do pipe_through [:browser, :admins_only] live_dashboard &quot;/dashboard&quot; endIf you are running your application behind a proxy or a webserver, you also have to make sure they are configured for allowing WebSocket upgrades. For example, here is an article on how to configure Nginx with Phoenix and WebSockets.Finally, you will also want to configure your config/prod.exs and use your domain name under the check_origin configuration:check_origin: [&quot;//myapp.com&quot;]Then you should be good to go!","ref":"Phoenix.LiveDashboard.html","title":"Phoenix.LiveDashboard","type":"module"},{"doc":"A plug that enables request logging.See our Request Logger guides for more information.","ref":"Phoenix.LiveDashboard.RequestLogger.html","title":"Phoenix.LiveDashboard.RequestLogger","type":"module"},{"doc":"Provides LiveView routing for LiveDashboard.","ref":"Phoenix.LiveDashboard.Router.html","title":"Phoenix.LiveDashboard.Router","type":"module"},{"doc":"Defines a LiveDashboard route.It expects the path the dashboard will be mounted at and a set of options.Options:metrics - Configures the module to retrieve metrics from. It can be a module or a {module, function}. If nothing is given, the metrics functionality will be disabled.:env_keys - Configures environment variables to display. It is defined as a list of string keys. If not set, the environment information will not be displayed.:live_socket_path - Configures the socket path. it must match the socket &quot;/live&quot;, Phoenix.LiveView.Socket in your endpoint.Examplesdefmodule MyAppWeb.Router do use Phoenix.Router import Phoenix.LiveDashboard.Router scope &quot;/&quot;, MyAppWeb do pipe_through [:browser] live_dashboard &quot;/dashboard&quot;, metrics: {MyAppWeb.Telemetry, :metrics}, env_keys: [&quot;APP_USER&quot;, &quot;VERSION&quot;] end end","ref":"Phoenix.LiveDashboard.Router.html#live_dashboard/2","title":"Phoenix.LiveDashboard.Router.live_dashboard/2","type":"macro"},{"doc":"Configuring metricsThis guide covers how to install and configure your LiveDashboard Metrics.","ref":"metrics.html","title":"Configuring metrics","type":"extras"},{"doc":"To enable the &quot;Metrics&quot; functionality in your dashboard, you will need to do the three steps below:Add the telemetry dependenciesDefine your telemetry moduleConfigure the dashboardAdd the telemetry dependenciesIn your mix.exs, add the following to your deps: {:telemetry_poller, &quot;~&gt; 0.4&quot;}, {:telemetry_metrics, &quot;~&gt; 0.4&quot;},If you generated your Phoenix app in version v1.5+, these dependencies will already be installed. You can also skip the next section.Define your telemetry moduleIn your Phoenix application, we recommend that you create a module to act as your telemetry supervision tree. Within this supervisor you can define your application's metrics and start your reporters.The example below contains the child spec for a LiveDashboard reporter, as well as some metrics definitions for telemetry events emitted by Phoenix, Ecto, and the VM (via the :telemetry_poller package).Create your Telemetry module in lib/my_app_web/telemetry.ex:defmodule MyAppWeb.Telemetry do use Supervisor import Telemetry.Metrics def start_link(arg) do Supervisor.start_link(__MODULE__, arg, name: __MODULE__) end @impl true def init(_arg) do children = [ # Telemetry poller will execute the given period measurements # every 10_000ms. Learn more here: https://hexdocs.pm/telemetry_metrics {:telemetry_poller, measurements: periodic_measurements(), period: 10_000} # Add reporters as children of your supervision tree. # {Telemetry.Metrics.ConsoleReporter, metrics: metrics()} ] Supervisor.init(children, strategy: :one_for_one) end def metrics do [ # Phoenix Metrics summary(&quot;phoenix.endpoint.stop.duration&quot;, unit: {:native, :millisecond} ), summary(&quot;phoenix.router_dispatch.stop.duration&quot;, tags: [:route], unit: {:native, :millisecond} ), # Database Time Metrics summary(&quot;my_app.repo.query.total_time&quot;, unit: {:native, :millisecond}), summary(&quot;my_app.repo.query.decode_time&quot;, unit: {:native, :millisecond}), summary(&quot;my_app.repo.query.query_time&quot;, unit: {:native, :millisecond}), summary(&quot;my_app.repo.query.queue_time&quot;, unit: {:native, :millisecond}), summary(&quot;my_app.repo.query.idle_time&quot;, unit: {:native, :millisecond}), # VM Metrics summary(&quot;vm.memory.total&quot;, unit: {:byte, :kilobyte}), summary(&quot;vm.total_run_queue_lengths.total&quot;), summary(&quot;vm.total_run_queue_lengths.cpu&quot;), summary(&quot;vm.total_run_queue_lengths.io&quot;) ] end defp periodic_measurements do [] end endMake sure to replace MyApp and my_app by your actual application name.Then add to your main application's supervision tree (usually in lib/my_app/application.ex):children = [ MyApp.Repo, MyAppWeb.Telemetry, MyAppWeb.Endpoint, ... ]Configure the dashboardThe last step now is to configure the dashboard. Go to the live_dashboard call in your router and add the following option:live_dashboard &quot;/dashboard&quot;, metrics: MyAppWeb.TelemetryNow refresh the &quot;/dashboard&quot; page and the metrics functionality should be enabled. Each metric goes to a distinct group based on the metric name itself.","ref":"metrics.html#installing-metrics","title":"Configuring metrics - Installing metrics","type":"extras"},{"doc":"Now that you have metrics up and running, you can begin exploring the rest of the telemetry ecosystem! Here are a few links to get you started:The Telemetry.Metrics module documentation contains more information on:Metric typesBreaking down metrics by tagsVM MetricsCustom periodic pollingFor a deeper dive into Phoenix and Ecto metrics, see our Telemetry Walkthrough.For more Elixir libraries using :telemetry, see Libraries using Telemetry.","ref":"metrics.html#more-about-telemetry","title":"Configuring metrics - More about telemetry","type":"extras"},{"doc":"The LiveDashboard integrates with :telemetry converting each Telemetry.Metrics to a beautiful, real-time chart.The following table shows how Telemetry.Metrics metrics map to LiveDashboard charts:Telemetry.MetricsY-Axis Value(s)last_valueAlways set to an absolute valuecounterAlways increased by 1sumAlways increased/decreased by an absolute valuesummaryValue/Min/Max/Avgdistribution(Coming Soon) recording measurements in individual bucketsReporter optionsReporter options can be given to each metric as an option. For example:counter(&quot;my_app.counter&quot;, reporter_options: [...])The following reporter options are available to the dashboard::group - configures the group the metric belongs to. By default the group is the first part of the name. For example, counter(&quot;my_app.counter&quot;) defaults to group &quot;my_app&quot;","ref":"metrics.html#configure-metrics","title":"Configuring metrics - Configure Metrics","type":"extras"},{"doc":"Configuring request loggerThis guide covers how to install and configure your LiveDashboard request logger.","ref":"request_logger.html","title":"Configuring request logger","type":"extras"},{"doc":"Installing the request logger is straight-forward. Just add the following plug to your &quot;lib/my_app_web/endpoint.ex&quot;, right before Plug.RequestId:plug Phoenix.LiveDashboard.RequestLogger, param_key: &quot;request_logger&quot;, cookie_key: &quot;request_logger&quot;If your application is an API only, then you most likely don't use cookies, which means you can remove the &quot;cookie_key&quot; option.Now go to your dashboard and the Request Logger will be enabled. Once you click it, you will have the option to either pass a parameter to stream requests logs or to enable/disable a cookie that streams requests logs.","ref":"request_logger.html#installing-request-logger","title":"Configuring request logger - Installing request logger","type":"extras"},{"doc":"There is no configuration for the request logger at the moment.","ref":"request_logger.html#configuring-request-logger","title":"Configuring request logger - Configuring request logger","type":"extras"},{"doc":"Configuring OS DataThis guide covers how to install and configure your LiveDashboard OS Data.","ref":"os_mon.html","title":"Configuring OS Data","type":"extras"},{"doc":"The OS Data comes from the os_mon application, which ships as part of your Erlang distribution. You can start it by adding it to the extra applications section in your mix.exs: def application do [ ..., extra_applications: [:logger, :runtime_tools, :os_mon] ] end","ref":"os_mon.html#enabling-os_mon","title":"Configuring OS Data - Enabling os_mon","type":"extras"},{"doc":"See the Erlang docs for more information and os_mon configuration.","ref":"os_mon.html#configuring-os_mon","title":"Configuring OS Data - Configuring os_mon","type":"extras"}]